curl --request POST \
--url https://developer.synq.io/api/entities/activity/v1alpha/person \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"identities": [
"<string>"
],
"until": "2023-01-15T01:30:15.01Z",
"windowDays": 91,
"directions": [],
"pagination": {
"cursor": "<string>",
"pageSize": 1
}
}
'import requests
url = "https://developer.synq.io/api/entities/activity/v1alpha/person"
payload = {
"identities": ["<string>"],
"until": "2023-01-15T01:30:15.01Z",
"windowDays": 91,
"directions": [],
"pagination": {
"cursor": "<string>",
"pageSize": 1
}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
identities: ['<string>'],
until: '2023-01-15T01:30:15.01Z',
windowDays: 91,
directions: [],
pagination: {cursor: '<string>', pageSize: 1}
})
};
fetch('https://developer.synq.io/api/entities/activity/v1alpha/person', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://developer.synq.io/api/entities/activity/v1alpha/person",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'identities' => [
'<string>'
],
'until' => '2023-01-15T01:30:15.01Z',
'windowDays' => 91,
'directions' => [
],
'pagination' => [
'cursor' => '<string>',
'pageSize' => 1
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://developer.synq.io/api/entities/activity/v1alpha/person"
payload := strings.NewReader("{\n \"identities\": [\n \"<string>\"\n ],\n \"until\": \"2023-01-15T01:30:15.01Z\",\n \"windowDays\": 91,\n \"directions\": [],\n \"pagination\": {\n \"cursor\": \"<string>\",\n \"pageSize\": 1\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://developer.synq.io/api/entities/activity/v1alpha/person")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"identities\": [\n \"<string>\"\n ],\n \"until\": \"2023-01-15T01:30:15.01Z\",\n \"windowDays\": 91,\n \"directions\": [],\n \"pagination\": {\n \"cursor\": \"<string>\",\n \"pageSize\": 1\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://developer.synq.io/api/entities/activity/v1alpha/person")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"identities\": [\n \"<string>\"\n ],\n \"until\": \"2023-01-15T01:30:15.01Z\",\n \"windowDays\": 91,\n \"directions\": [],\n \"pagination\": {\n \"cursor\": \"<string>\",\n \"pageSize\": 1\n }\n}"
response = http.request(request)
puts response.read_body{
"entities": [
{
"entityId": "<string>",
"direction": "ACTIVITY_DIRECTION_UNSPECIFIED",
"measure": "ACTIVITY_MEASURE_UNSPECIFIED",
"count": 123,
"lastSeenAt": "2023-01-15T01:30:15.01Z"
}
],
"platformUserIds": [
"<string>"
],
"from": "2023-01-15T01:30:15.01Z",
"to": "2023-01-15T01:30:15.01Z",
"pageInfo": {
"totalCount": 123,
"count": 123,
"lastId": "<string>"
}
}ListPersonActivity
Read what one person’s logins read and wrote over the window, per entity, direction and measure. What a colleague read is personal data, so a user caller needs the platform users scope from its role, which a Developer and an Admin have. Logins in a service account, and Coalesce Quality’s own queries, are never part of the answer.
curl --request POST \
--url https://developer.synq.io/api/entities/activity/v1alpha/person \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"identities": [
"<string>"
],
"until": "2023-01-15T01:30:15.01Z",
"windowDays": 91,
"directions": [],
"pagination": {
"cursor": "<string>",
"pageSize": 1
}
}
'import requests
url = "https://developer.synq.io/api/entities/activity/v1alpha/person"
payload = {
"identities": ["<string>"],
"until": "2023-01-15T01:30:15.01Z",
"windowDays": 91,
"directions": [],
"pagination": {
"cursor": "<string>",
"pageSize": 1
}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
identities: ['<string>'],
until: '2023-01-15T01:30:15.01Z',
windowDays: 91,
directions: [],
pagination: {cursor: '<string>', pageSize: 1}
})
};
fetch('https://developer.synq.io/api/entities/activity/v1alpha/person', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://developer.synq.io/api/entities/activity/v1alpha/person",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'identities' => [
'<string>'
],
'until' => '2023-01-15T01:30:15.01Z',
'windowDays' => 91,
'directions' => [
],
'pagination' => [
'cursor' => '<string>',
'pageSize' => 1
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://developer.synq.io/api/entities/activity/v1alpha/person"
payload := strings.NewReader("{\n \"identities\": [\n \"<string>\"\n ],\n \"until\": \"2023-01-15T01:30:15.01Z\",\n \"windowDays\": 91,\n \"directions\": [],\n \"pagination\": {\n \"cursor\": \"<string>\",\n \"pageSize\": 1\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://developer.synq.io/api/entities/activity/v1alpha/person")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"identities\": [\n \"<string>\"\n ],\n \"until\": \"2023-01-15T01:30:15.01Z\",\n \"windowDays\": 91,\n \"directions\": [],\n \"pagination\": {\n \"cursor\": \"<string>\",\n \"pageSize\": 1\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://developer.synq.io/api/entities/activity/v1alpha/person")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"identities\": [\n \"<string>\"\n ],\n \"until\": \"2023-01-15T01:30:15.01Z\",\n \"windowDays\": 91,\n \"directions\": [],\n \"pagination\": {\n \"cursor\": \"<string>\",\n \"pageSize\": 1\n }\n}"
response = http.request(request)
puts response.read_body{
"entities": [
{
"entityId": "<string>",
"direction": "ACTIVITY_DIRECTION_UNSPECIFIED",
"measure": "ACTIVITY_MEASURE_UNSPECIFIED",
"count": 123,
"lastSeenAt": "2023-01-15T01:30:15.01Z"
}
],
"platformUserIds": [
"<string>"
],
"from": "2023-01-15T01:30:15.01Z",
"to": "2023-01-15T01:30:15.01Z",
"pageInfo": {
"totalCount": 123,
"count": 123,
"lastId": "<string>"
}
}Authorizations
Bearer authentication header of the form Bearer <token>, where <token> is your auth token.
Body
The identities of one person, as synq.users.v1 gives them, such as "synq:<user_id>", "email:
" or "platform_user:".1 - 200 elements1 - 2048The window ends at the start of this hour, exclusive. Unset is the current hour.
"2023-01-15T01:30:15.01Z"
"2024-12-25T12:00:00Z"
The window's length in days, back from until. Unset is 30.
x <= 92Only these directions. Empty keeps every one.
ActivityDirection is how a query touched an entity.
ACTIVITY_DIRECTION_UNSPECIFIED, ACTIVITY_DIRECTION_READ, ACTIVITY_DIRECTION_INPUT, ACTIVITY_DIRECTION_WRITE Without a page size every entity is returned.
Show child attributes
Show child attributes
Response
Success
Ordered by count, highest first, then entity id, direction and measure.
Show child attributes
Show child attributes
The logins the identities resolved to, sorted.
A Timestamp represents a point in time independent of any time zone or local calendar, encoded as a count of seconds and fractions of seconds at nanosecond resolution. The count is relative to an epoch at UTC midnight on January 1, 1970, in the proleptic Gregorian calendar which extends the Gregorian calendar backwards to year one.
All minutes are 60 seconds long. Leap seconds are "smeared" so that no leap second table is needed for interpretation, using a 24-hour linear smear.
The range is from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z. By restricting to that range, we ensure that we can convert to and from RFC 3339 date strings.
Examples
Example 1: Compute Timestamp from POSIX time().
Timestamp timestamp;
timestamp.set_seconds(time(NULL));
timestamp.set_nanos(0);
Example 2: Compute Timestamp from POSIX gettimeofday().
struct timeval tv;
gettimeofday(&tv, NULL);
Timestamp timestamp;
timestamp.set_seconds(tv.tv_sec);
timestamp.set_nanos(tv.tv_usec * 1000);
Example 3: Compute Timestamp from Win32 GetSystemTimeAsFileTime().
FILETIME ft;
GetSystemTimeAsFileTime(&ft);
UINT64 ticks = (((UINT64)ft.dwHighDateTime) << 32) | ft.dwLowDateTime;
// A Windows tick is 100 nanoseconds. Windows epoch 1601-01-01T00:00:00Z
// is 11644473600 seconds before Unix epoch 1970-01-01T00:00:00Z.
Timestamp timestamp;
timestamp.set_seconds((INT64) ((ticks / 10000000) - 11644473600LL));
timestamp.set_nanos((INT32) ((ticks % 10000000) * 100));
Example 4: Compute Timestamp from Java System.currentTimeMillis().
long millis = System.currentTimeMillis();
Timestamp timestamp = Timestamp.newBuilder().setSeconds(millis / 1000)
.setNanos((int) ((millis % 1000) * 1000000)).build();
Example 5: Compute Timestamp from Java Instant.now().
Instant now = Instant.now();
Timestamp timestamp =
Timestamp.newBuilder().setSeconds(now.getEpochSecond())
.setNanos(now.getNano()).build();
Example 6: Compute Timestamp from current time in Python.
timestamp = Timestamp()
timestamp.GetCurrentTime()
JSON Mapping
In JSON format, the Timestamp type is encoded as a string in the RFC 3339 format. That is, the format is "{year}-{month}-{day}T{hour}:{min}:{sec}[.{frac_sec}]Z" where {year} is always expressed using four digits while {month}, {day}, {hour}, {min}, and {sec} are zero-padded to two digits each. The fractional seconds, which can go up to 9 digits (i.e. up to 1 nanosecond resolution), are optional. The "Z" suffix indicates the timezone ("UTC"); the timezone is required. A proto3 JSON serializer should always use UTC (as indicated by "Z") when printing the Timestamp type and a proto3 JSON parser should be able to accept both UTC and other timezones (as indicated by an offset).
For example, "2017-01-15T01:30:15.01Z" encodes 15.01 seconds past 01:30 UTC on January 15, 2017.
In JavaScript, one can convert a Date object to this format using the
standard
toISOString()
method. In Python, a standard datetime.datetime object can be converted
to this format using
strftime with
the time format spec '%Y-%m-%dT%H:%M:%S.%fZ'. Likewise, in Java, one can use
the Joda Time's ISODateTimeFormat.dateTime() to obtain a formatter capable of generating timestamps in this format.
"2023-01-15T01:30:15.01Z"
"2024-12-25T12:00:00Z"
A Timestamp represents a point in time independent of any time zone or local calendar, encoded as a count of seconds and fractions of seconds at nanosecond resolution. The count is relative to an epoch at UTC midnight on January 1, 1970, in the proleptic Gregorian calendar which extends the Gregorian calendar backwards to year one.
All minutes are 60 seconds long. Leap seconds are "smeared" so that no leap second table is needed for interpretation, using a 24-hour linear smear.
The range is from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z. By restricting to that range, we ensure that we can convert to and from RFC 3339 date strings.
Examples
Example 1: Compute Timestamp from POSIX time().
Timestamp timestamp;
timestamp.set_seconds(time(NULL));
timestamp.set_nanos(0);
Example 2: Compute Timestamp from POSIX gettimeofday().
struct timeval tv;
gettimeofday(&tv, NULL);
Timestamp timestamp;
timestamp.set_seconds(tv.tv_sec);
timestamp.set_nanos(tv.tv_usec * 1000);
Example 3: Compute Timestamp from Win32 GetSystemTimeAsFileTime().
FILETIME ft;
GetSystemTimeAsFileTime(&ft);
UINT64 ticks = (((UINT64)ft.dwHighDateTime) << 32) | ft.dwLowDateTime;
// A Windows tick is 100 nanoseconds. Windows epoch 1601-01-01T00:00:00Z
// is 11644473600 seconds before Unix epoch 1970-01-01T00:00:00Z.
Timestamp timestamp;
timestamp.set_seconds((INT64) ((ticks / 10000000) - 11644473600LL));
timestamp.set_nanos((INT32) ((ticks % 10000000) * 100));
Example 4: Compute Timestamp from Java System.currentTimeMillis().
long millis = System.currentTimeMillis();
Timestamp timestamp = Timestamp.newBuilder().setSeconds(millis / 1000)
.setNanos((int) ((millis % 1000) * 1000000)).build();
Example 5: Compute Timestamp from Java Instant.now().
Instant now = Instant.now();
Timestamp timestamp =
Timestamp.newBuilder().setSeconds(now.getEpochSecond())
.setNanos(now.getNano()).build();
Example 6: Compute Timestamp from current time in Python.
timestamp = Timestamp()
timestamp.GetCurrentTime()
JSON Mapping
In JSON format, the Timestamp type is encoded as a string in the RFC 3339 format. That is, the format is "{year}-{month}-{day}T{hour}:{min}:{sec}[.{frac_sec}]Z" where {year} is always expressed using four digits while {month}, {day}, {hour}, {min}, and {sec} are zero-padded to two digits each. The fractional seconds, which can go up to 9 digits (i.e. up to 1 nanosecond resolution), are optional. The "Z" suffix indicates the timezone ("UTC"); the timezone is required. A proto3 JSON serializer should always use UTC (as indicated by "Z") when printing the Timestamp type and a proto3 JSON parser should be able to accept both UTC and other timezones (as indicated by an offset).
For example, "2017-01-15T01:30:15.01Z" encodes 15.01 seconds past 01:30 UTC on January 15, 2017.
In JavaScript, one can convert a Date object to this format using the
standard
toISOString()
method. In Python, a standard datetime.datetime object can be converted
to this format using
strftime with
the time format spec '%Y-%m-%dT%H:%M:%S.%fZ'. Likewise, in Java, one can use
the Joda Time's ISODateTimeFormat.dateTime() to obtain a formatter capable of generating timestamps in this format.
"2023-01-15T01:30:15.01Z"
"2024-12-25T12:00:00Z"
Show child attributes
Show child attributes